
/* This template is based off of the KOffice example written by Torben Weis <weis@kde.org
   It was converted to a KDevelop template by Ian Reinhart Geiser <geiseri@yahoo.com>
*/

#include "%{APPNAMELC}_part.h"
#include "%{APPNAMELC}_view.h"

#include <tqpainter.h>

%{APPNAME}Part::%{APPNAME}Part( TQWidget *parentWidget, const char *widgetName, TQObject* parent, const char* name, bool singleViewMode )
    : KoDocument( parentWidget, widgetName, parent, name, singleViewMode )
{
}

bool %{APPNAME}Part::initDoc( InitDocFlags flags, TQWidget* parentWidget )
{
    // If nothing is loaded, do initialize here
    return TRUE;
}

KoView* %{APPNAME}Part::createViewInstance( TQWidget* parent, const char* name )
{
    return new %{APPNAME}View( this, parent, name );
}

bool %{APPNAME}Part::loadOasis( const TQDomDocument & doc, KoOasisStyles& oasisStyles, const TQDomDocument & settings, KoStore* store )
{
    /// @todo load the document using the OASIS format
    return true;
}

bool %{APPNAME}Part::loadXML( TQIODevice *, const TQDomDocument & )
{
    /// @todo load the document from the TQDomDocument
    return true;
}

TQDomDocument %{APPNAME}Part::saveXML()
{
    /// @todo save the document into a TQDomDocument
    return TQDomDocument();
}

bool %{APPNAME}Part::saveOasis( KoStore* store, KoXmlWriter* manifestWriter )
{
    /// @todo save the document using the OASIS format
    return true;
}


void %{APPNAME}Part::paintContent( TQPainter& painter, const TQRect& rect, bool /*transparent*/,
                                double /*zoomX*/, double /*zoomY*/ )
{
    // ####### handle transparency

    // Need to draw only the document rectangle described in the parameter rect.
    int left = rect.left() / 20;
    int right = rect.right() / 20 + 1;
    int top = rect.top() / 20;
    int bottom = rect.bottom() / 20 + 1;

    for( int x = left; x < right; ++x )
        painter.drawLine( x * 20, top * 20, x * 20, bottom * 20 );
    for( int y = left; y < right; ++y )
        painter.drawLine( left * 20, y * 20, right * 20, y * 20 );
}

#include "%{APPNAMELC}_part.moc"
